xref: /openbmc/qemu/tests/qemu-iotests/common.rc (revision 3cad405b)
1#!/usr/bin/env bash
2#
3# Copyright (C) 2009 Red Hat, Inc.
4# Copyright (c) 2000-2006 Silicon Graphics, Inc.  All Rights Reserved.
5#
6# This program is free software; you can redistribute it and/or modify
7# it under the terms of the GNU General Public License as published by
8# the Free Software Foundation; either version 2 of the License, or
9# (at your option) any later version.
10#
11# This program is distributed in the hope that it will be useful,
12# but WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
14# GNU General Public License for more details.
15#
16# You should have received a copy of the GNU General Public License
17# along with this program.  If not, see <http://www.gnu.org/licenses/>.
18#
19
20SED=
21for sed in sed gsed; do
22    ($sed --version | grep 'GNU sed') > /dev/null 2>&1
23    if [ "$?" -eq 0 ]; then
24        SED=$sed
25        break
26    fi
27done
28if [ -z "$SED" ]; then
29    echo "$0: GNU sed not found"
30    exit 1
31fi
32
33dd()
34{
35   if [ "$HOSTOS" == "Linux" ]
36   then
37        command dd --help | grep noxfer > /dev/null 2>&1
38
39        if [ "$?" -eq 0 ]
40            then
41                command dd status=noxfer $@
42            else
43                command dd $@
44            fi
45   else
46        command dd $@
47   fi
48}
49
50# poke_file 'test.img' 512 '\xff\xfe'
51poke_file()
52{
53    printf "$3" | dd "of=$1" bs=1 "seek=$2" conv=notrunc &>/dev/null
54}
55
56# peek_file_le 'test.img' 512 2 => 65534
57peek_file_le()
58{
59    # Wrap in echo $() to strip spaces
60    echo $(od -j"$2" -N"$3" --endian=little -An -vtu"$3" "$1")
61}
62
63# peek_file_be 'test.img' 512 2 => 65279
64peek_file_be()
65{
66    # Wrap in echo $() to strip spaces
67    echo $(od -j"$2" -N"$3" --endian=big -An -vtu"$3" "$1")
68}
69
70# peek_file_raw 'test.img' 512 2 => '\xff\xfe'
71peek_file_raw()
72{
73    dd if="$1" bs=1 skip="$2" count="$3" status=none
74}
75
76
77if ! . ./common.config
78    then
79    echo "$0: failed to source common.config"
80    exit 1
81fi
82
83# Set the variables to the empty string to turn Valgrind off
84# for specific processes, e.g.
85# $ VALGRIND_QEMU_IO= ./check -qcow2 -valgrind 015
86
87: ${VALGRIND_QEMU_VM=$VALGRIND_QEMU}
88: ${VALGRIND_QEMU_IMG=$VALGRIND_QEMU}
89: ${VALGRIND_QEMU_IO=$VALGRIND_QEMU}
90: ${VALGRIND_QEMU_NBD=$VALGRIND_QEMU}
91: ${VALGRIND_QEMU_VXHS=$VALGRIND_QEMU}
92
93# The Valgrind own parameters may be set with
94# its environment variable VALGRIND_OPTS, e.g.
95# $ VALGRIND_OPTS="--leak-check=yes" ./check -qcow2 -valgrind 015
96
97_qemu_proc_exec()
98{
99    local VALGRIND_LOGFILE="$1"
100    shift
101    if [[ "${VALGRIND_QEMU}" == "y" && "${NO_VALGRIND}" != "y" ]]; then
102        exec valgrind --log-file="${VALGRIND_LOGFILE}" --error-exitcode=99 "$@"
103    else
104        exec "$@"
105    fi
106}
107
108_qemu_proc_valgrind_log()
109{
110    local VALGRIND_LOGFILE="$1"
111    local RETVAL="$2"
112    if [[ "${VALGRIND_QEMU}" == "y" && "${NO_VALGRIND}" != "y" ]]; then
113        if [ $RETVAL == 99 ]; then
114            cat "${VALGRIND_LOGFILE}"
115        fi
116        rm -f "${VALGRIND_LOGFILE}"
117    fi
118}
119
120_qemu_wrapper()
121{
122    local VALGRIND_LOGFILE="${TEST_DIR}"/$$.valgrind
123    (
124        if [ -n "${QEMU_NEED_PID}" ]; then
125            echo $BASHPID > "${QEMU_TEST_DIR}/qemu-${_QEMU_HANDLE}.pid"
126        fi
127        VALGRIND_QEMU="${VALGRIND_QEMU_VM}" _qemu_proc_exec "${VALGRIND_LOGFILE}" \
128            "$QEMU_PROG" $QEMU_OPTIONS "$@"
129    )
130    RETVAL=$?
131    _qemu_proc_valgrind_log "${VALGRIND_LOGFILE}" $RETVAL
132    return $RETVAL
133}
134
135_qemu_img_wrapper()
136{
137    local VALGRIND_LOGFILE="${TEST_DIR}"/$$.valgrind
138    (
139        VALGRIND_QEMU="${VALGRIND_QEMU_IMG}" _qemu_proc_exec "${VALGRIND_LOGFILE}" \
140            "$QEMU_IMG_PROG" $QEMU_IMG_OPTIONS "$@"
141    )
142    RETVAL=$?
143    _qemu_proc_valgrind_log "${VALGRIND_LOGFILE}" $RETVAL
144    return $RETVAL
145}
146
147_qemu_io_wrapper()
148{
149    local VALGRIND_LOGFILE="${TEST_DIR}"/$$.valgrind
150    local QEMU_IO_ARGS="$QEMU_IO_OPTIONS"
151    if [ "$IMGOPTSSYNTAX" = "true" ]; then
152        QEMU_IO_ARGS="--image-opts $QEMU_IO_ARGS"
153        if [ -n "$IMGKEYSECRET" ]; then
154            QEMU_IO_ARGS="--object secret,id=keysec0,data=$IMGKEYSECRET $QEMU_IO_ARGS"
155        fi
156    fi
157    (
158        VALGRIND_QEMU="${VALGRIND_QEMU_IO}" _qemu_proc_exec "${VALGRIND_LOGFILE}" \
159            "$QEMU_IO_PROG" $QEMU_IO_ARGS "$@"
160    )
161    RETVAL=$?
162    _qemu_proc_valgrind_log "${VALGRIND_LOGFILE}" $RETVAL
163    return $RETVAL
164}
165
166_qemu_nbd_wrapper()
167{
168    local VALGRIND_LOGFILE="${TEST_DIR}"/$$.valgrind
169    (
170        VALGRIND_QEMU="${VALGRIND_QEMU_NBD}" _qemu_proc_exec "${VALGRIND_LOGFILE}" \
171            "$QEMU_NBD_PROG" --pid-file="${QEMU_TEST_DIR}/qemu-nbd.pid" \
172             $QEMU_NBD_OPTIONS "$@"
173    )
174    RETVAL=$?
175    _qemu_proc_valgrind_log "${VALGRIND_LOGFILE}" $RETVAL
176    return $RETVAL
177}
178
179_qemu_vxhs_wrapper()
180{
181    local VALGRIND_LOGFILE="${TEST_DIR}"/$$.valgrind
182    (
183        echo $BASHPID > "${TEST_DIR}/qemu-vxhs.pid"
184        VALGRIND_QEMU="${VALGRIND_QEMU_VXHS}" _qemu_proc_exec "${VALGRIND_LOGFILE}" \
185            "$QEMU_VXHS_PROG" $QEMU_VXHS_OPTIONS "$@"
186    )
187    RETVAL=$?
188    _qemu_proc_valgrind_log "${VALGRIND_LOGFILE}" $RETVAL
189    return $RETVAL
190}
191
192# Valgrind bug #409141 https://bugs.kde.org/show_bug.cgi?id=409141
193# Until valgrind 3.16+ is ubiquitous, we must work around a hang in
194# valgrind when issuing sigkill. Disable valgrind for this invocation.
195_NO_VALGRIND()
196{
197    NO_VALGRIND="y" "$@"
198}
199
200export QEMU=_qemu_wrapper
201export QEMU_IMG=_qemu_img_wrapper
202export QEMU_IO=_qemu_io_wrapper
203export QEMU_NBD=_qemu_nbd_wrapper
204export QEMU_VXHS=_qemu_vxhs_wrapper
205
206if [ "$IMGOPTSSYNTAX" = "true" ]; then
207    DRIVER="driver=$IMGFMT"
208    QEMU_IMG_EXTRA_ARGS="--image-opts $QEMU_IMG_EXTRA_ARGS"
209    if [ -n "$IMGKEYSECRET" ]; then
210        QEMU_IMG_EXTRA_ARGS="--object secret,id=keysec0,data=$IMGKEYSECRET $QEMU_IMG_EXTRA_ARGS"
211    fi
212    if [ "$IMGFMT" = "luks" ]; then
213        DRIVER="$DRIVER,key-secret=keysec0"
214    fi
215    if [ "$IMGPROTO" = "file" ]; then
216        TEST_IMG_FILE=$TEST_DIR/t.$IMGFMT
217        TEST_IMG="$DRIVER,file.filename=$TEST_DIR/t.$IMGFMT"
218    elif [ "$IMGPROTO" = "nbd" ]; then
219        TEST_IMG_FILE=$TEST_DIR/t.$IMGFMT
220        TEST_IMG="$DRIVER,file.driver=nbd,file.type=unix"
221        TEST_IMG="$TEST_IMG,file.path=$SOCK_DIR/nbd"
222    elif [ "$IMGPROTO" = "ssh" ]; then
223        TEST_IMG_FILE=$TEST_DIR/t.$IMGFMT
224        TEST_IMG="$DRIVER,file.driver=ssh,file.host=127.0.0.1,file.path=$TEST_IMG_FILE"
225    elif [ "$IMGPROTO" = "nfs" ]; then
226        TEST_DIR="$DRIVER,file.driver=nfs,file.filename=nfs://127.0.0.1/$TEST_DIR"
227        TEST_IMG=$TEST_DIR/t.$IMGFMT
228    else
229        TEST_IMG="$DRIVER,file.driver=$IMGPROTO,file.filename=$TEST_DIR/t.$IMGFMT"
230    fi
231else
232    QEMU_IMG_EXTRA_ARGS=
233    if [ "$IMGPROTO" = "file" ]; then
234        TEST_IMG=$TEST_DIR/t.$IMGFMT
235    elif [ "$IMGPROTO" = "nbd" ]; then
236        TEST_IMG_FILE=$TEST_DIR/t.$IMGFMT
237        TEST_IMG="nbd+unix:///?socket=$SOCK_DIR/nbd"
238    elif [ "$IMGPROTO" = "ssh" ]; then
239        TEST_IMG_FILE=$TEST_DIR/t.$IMGFMT
240        REMOTE_TEST_DIR="ssh://\\($USER@\\)\\?127.0.0.1\\(:[0-9]\\+\\)\\?$TEST_DIR"
241        TEST_IMG="ssh://127.0.0.1$TEST_IMG_FILE"
242    elif [ "$IMGPROTO" = "nfs" ]; then
243        TEST_IMG_FILE=$TEST_DIR/t.$IMGFMT
244        REMOTE_TEST_DIR="nfs://127.0.0.1$TEST_DIR"
245        TEST_IMG="nfs://127.0.0.1$TEST_IMG_FILE"
246    elif [ "$IMGPROTO" = "vxhs" ]; then
247        TEST_IMG_FILE=$TEST_DIR/t.$IMGFMT
248        TEST_IMG="vxhs://127.0.0.1:9999/t.$IMGFMT"
249    else
250        TEST_IMG=$IMGPROTO:$TEST_DIR/t.$IMGFMT
251    fi
252fi
253ORIG_TEST_IMG="$TEST_IMG"
254
255if [ -z "$TEST_DIR" ]; then
256        TEST_DIR=$PWD/scratch
257fi
258
259QEMU_TEST_DIR="${TEST_DIR}"
260
261if [ ! -e "$TEST_DIR" ]; then
262        mkdir "$TEST_DIR"
263fi
264
265if [ ! -d "$TEST_DIR" ]; then
266    echo "common.rc: Error: \$TEST_DIR ($TEST_DIR) is not a directory"
267    exit 1
268fi
269
270if [ -z "$REMOTE_TEST_DIR" ]; then
271    REMOTE_TEST_DIR="$TEST_DIR"
272fi
273
274if [ ! -d "$SAMPLE_IMG_DIR" ]; then
275    echo "common.rc: Error: \$SAMPLE_IMG_DIR ($SAMPLE_IMG_DIR) is not a directory"
276    exit 1
277fi
278
279_use_sample_img()
280{
281    SAMPLE_IMG_FILE="${1%\.bz2}"
282    TEST_IMG="$TEST_DIR/$SAMPLE_IMG_FILE"
283    bzcat "$SAMPLE_IMG_DIR/$1" > "$TEST_IMG"
284    if [ $? -ne 0 ]
285    then
286        echo "_use_sample_img error, cannot extract '$SAMPLE_IMG_DIR/$1'"
287        exit 1
288    fi
289}
290
291_stop_nbd_server()
292{
293    if [ -f "${QEMU_TEST_DIR}/qemu-nbd.pid" ]; then
294        local QEMU_NBD_PID
295        read QEMU_NBD_PID < "${QEMU_TEST_DIR}/qemu-nbd.pid"
296        kill ${QEMU_NBD_PID}
297        rm -f "${QEMU_TEST_DIR}/qemu-nbd.pid" "$SOCK_DIR/nbd"
298    fi
299}
300
301_make_test_img()
302{
303    # extra qemu-img options can be added by tests
304    # at least one argument (the image size) needs to be added
305    local extra_img_options=""
306    local image_size=$*
307    local optstr=""
308    local img_name=""
309    local use_backing=0
310    local backing_file=""
311    local object_options=""
312
313    if [ -n "$TEST_IMG_FILE" ]; then
314        img_name=$TEST_IMG_FILE
315    else
316        img_name=$TEST_IMG
317    fi
318
319    if [ -n "$IMGOPTS" ]; then
320        optstr=$(_optstr_add "$optstr" "$IMGOPTS")
321    fi
322    if [ -n "$IMGKEYSECRET" ]; then
323        object_options="--object secret,id=keysec0,data=$IMGKEYSECRET"
324        optstr=$(_optstr_add "$optstr" "key-secret=keysec0")
325    fi
326
327    if [ "$1" = "-b" ]; then
328        use_backing=1
329        backing_file=$2
330        image_size=$3
331    fi
332    if [ \( "$IMGFMT" = "qcow2" -o "$IMGFMT" = "qed" \) -a -n "$CLUSTER_SIZE" ]; then
333        optstr=$(_optstr_add "$optstr" "cluster_size=$CLUSTER_SIZE")
334    fi
335
336    if [ -n "$optstr" ]; then
337        extra_img_options="-o $optstr $extra_img_options"
338    fi
339
340    if [ $IMGPROTO = "nbd" ]; then
341        _stop_nbd_server
342    fi
343
344    # XXX(hch): have global image options?
345    (
346     if [ $use_backing = 1 ]; then
347        $QEMU_IMG create $object_options -f $IMGFMT $extra_img_options -b "$backing_file" "$img_name" $image_size 2>&1
348     else
349        $QEMU_IMG create $object_options -f $IMGFMT $extra_img_options "$img_name" $image_size 2>&1
350     fi
351    ) | _filter_img_create
352
353    # Start an NBD server on the image file, which is what we'll be talking to.
354    # Once NBD gains resize support, we may also want to use -f raw at the
355    # server and interpret format over NBD, but for now, the format is
356    # interpreted at the server and raw data sent over NBD.
357    if [ $IMGPROTO = "nbd" ]; then
358        # Pass a sufficiently high number to -e that should be enough for all
359        # tests
360        eval "$QEMU_NBD -v -t -k '$SOCK_DIR/nbd' -f $IMGFMT -e 42 -x '' $TEST_IMG_FILE >/dev/null &"
361        sleep 1 # FIXME: qemu-nbd needs to be listening before we continue
362    fi
363
364    # Start QNIO server on image directory for vxhs protocol
365    if [ $IMGPROTO = "vxhs" ]; then
366        eval "$QEMU_VXHS -d  $TEST_DIR > /dev/null &"
367        sleep 1 # Wait for server to come up.
368    fi
369}
370
371_rm_test_img()
372{
373    local img=$1
374    if [ "$IMGFMT" = "vmdk" ]; then
375        # Remove all the extents for vmdk
376        "$QEMU_IMG" info "$img" 2>/dev/null | grep 'filename:' | cut -f 2 -d: \
377            | xargs -I {} rm -f "{}"
378    fi
379    rm -f "$img"
380}
381
382_cleanup_test_img()
383{
384    case "$IMGPROTO" in
385
386        nbd)
387            _stop_nbd_server
388            rm -f "$TEST_IMG_FILE"
389            ;;
390        vxhs)
391            if [ -f "${TEST_DIR}/qemu-vxhs.pid" ]; then
392                local QEMU_VXHS_PID
393                read QEMU_VXHS_PID < "${TEST_DIR}/qemu-vxhs.pid"
394                kill ${QEMU_VXHS_PID} >/dev/null 2>&1
395                rm -f "${TEST_DIR}/qemu-vxhs.pid"
396            fi
397            rm -f "$TEST_IMG_FILE"
398            ;;
399
400        file)
401            _rm_test_img "$TEST_DIR/t.$IMGFMT"
402            _rm_test_img "$TEST_DIR/t.$IMGFMT.orig"
403            _rm_test_img "$TEST_DIR/t.$IMGFMT.base"
404            if [ -n "$SAMPLE_IMG_FILE" ]
405            then
406                rm -f "$TEST_DIR/$SAMPLE_IMG_FILE"
407                SAMPLE_IMG_FILE=
408                TEST_IMG="$ORIG_TEST_IMG"
409            fi
410            ;;
411
412        rbd)
413            rbd --no-progress rm "$TEST_DIR/t.$IMGFMT" > /dev/null
414            ;;
415
416        sheepdog)
417            collie vdi delete "$TEST_DIR/t.$IMGFMT"
418            ;;
419
420    esac
421}
422
423_check_test_img()
424{
425    (
426        if [ "$IMGOPTSSYNTAX" = "true" ]; then
427            $QEMU_IMG check $QEMU_IMG_EXTRA_ARGS "$@" "$TEST_IMG" 2>&1
428        else
429            $QEMU_IMG check "$@" -f $IMGFMT "$TEST_IMG" 2>&1
430        fi
431    ) | _filter_testdir | _filter_qemu_img_check
432
433    # return real qemu_img check status, to analyze in
434    # _check_test_img_ignore_leaks
435    return ${PIPESTATUS[0]}
436}
437
438_check_test_img_ignore_leaks()
439{
440    out=$(_check_test_img "$@")
441    status=$?
442    if [ $status = 3 ]; then
443        # This must correspond to success output in dump_human_image_check()
444        echo "No errors were found on the image."
445        return 0
446    fi
447    echo "$out"
448    return $status
449}
450
451_img_info()
452{
453    if [[ "$1" == "--format-specific" ]]; then
454        local format_specific=1
455        shift
456    else
457        local format_specific=0
458    fi
459
460    discard=0
461    regex_json_spec_start='^ *"format-specific": \{'
462    $QEMU_IMG info $QEMU_IMG_EXTRA_ARGS "$@" "$TEST_IMG" 2>&1 | \
463        sed -e "s#$REMOTE_TEST_DIR#TEST_DIR#g" \
464            -e "s#$IMGPROTO:$TEST_DIR#TEST_DIR#g" \
465            -e "s#$TEST_DIR#TEST_DIR#g" \
466            -e "s#$IMGFMT#IMGFMT#g" \
467            -e "/^disk size:/ D" \
468            -e "/actual-size/ D" | \
469        while IFS='' read -r line; do
470            if [[ $format_specific == 1 ]]; then
471                discard=0
472            elif [[ $line == "Format specific information:" ]]; then
473                discard=1
474            elif [[ $line =~ $regex_json_spec_start ]]; then
475                discard=2
476                regex_json_spec_end="^${line%%[^ ]*}\\},? *$"
477            fi
478            if [[ $discard == 0 ]]; then
479                echo "$line"
480            elif [[ $discard == 1 && ! $line ]]; then
481                echo
482                discard=0
483            elif [[ $discard == 2 && $line =~ $regex_json_spec_end ]]; then
484                discard=0
485            fi
486        done
487}
488
489# bail out, setting up .notrun file
490#
491_notrun()
492{
493    echo "$*" >"$OUTPUT_DIR/$seq.notrun"
494    echo "$seq not run: $*"
495    status=0
496    exit
497}
498
499# bail out, setting up .casenotrun file
500# The function _casenotrun() is used as a notifier. It is the
501# caller's responsibility to make skipped a particular test.
502#
503_casenotrun()
504{
505    echo "    [case not run] $*" >>"$OUTPUT_DIR/$seq.casenotrun"
506}
507
508# just plain bail out
509#
510_fail()
511{
512    echo "$*" | tee -a "$OUTPUT_DIR/$seq.full"
513    echo "(see $seq.full for details)"
514    status=1
515    exit 1
516}
517
518# tests whether $IMGFMT is one of the supported image formats for a test
519#
520_supported_fmt()
521{
522    # "generic" is suitable for most image formats. For some formats it doesn't
523    # work, however (most notably read-only formats), so they can opt out by
524    # setting IMGFMT_GENERIC to false.
525    for f; do
526        if [ "$f" = "$IMGFMT" -o "$f" = "generic" -a "$IMGFMT_GENERIC" = "true" ]; then
527            return
528        fi
529    done
530
531    _notrun "not suitable for this image format: $IMGFMT"
532}
533
534# tests whether $IMGFMT is one of the unsupported image format for a test
535#
536_unsupported_fmt()
537{
538    for f; do
539        if [ "$f" = "$IMGFMT" ]; then
540            _notrun "not suitable for this image format: $IMGFMT"
541        fi
542    done
543}
544
545# tests whether $IMGPROTO is one of the supported image protocols for a test
546#
547_supported_proto()
548{
549    for f; do
550        if [ "$f" = "$IMGPROTO" -o "$f" = "generic" ]; then
551            return
552        fi
553    done
554
555    _notrun "not suitable for this image protocol: $IMGPROTO"
556}
557
558# tests whether $IMGPROTO is specified as an unsupported image protocol for a test
559#
560_unsupported_proto()
561{
562    for f; do
563        if [ "$f" = "$IMGPROTO" ]; then
564            _notrun "not suitable for this image protocol: $IMGPROTO"
565            return
566        fi
567    done
568}
569
570# tests whether the host OS is one of the supported OSes for a test
571#
572_supported_os()
573{
574    for h
575    do
576        if [ "$h" = "$HOSTOS" ]
577        then
578            return
579        fi
580    done
581
582    _notrun "not suitable for this OS: $HOSTOS"
583}
584
585_supported_cache_modes()
586{
587    for mode; do
588        if [ "$mode" = "$CACHEMODE" ]; then
589            return
590        fi
591    done
592    _notrun "not suitable for cache mode: $CACHEMODE"
593}
594
595_default_cache_mode()
596{
597    if $CACHEMODE_IS_DEFAULT; then
598        CACHEMODE="$1"
599        QEMU_IO="$QEMU_IO --cache $1"
600        return
601    fi
602}
603
604_unsupported_imgopts()
605{
606    for bad_opt
607    do
608        if echo "$IMGOPTS" | grep -q 2>/dev/null "$bad_opt"
609        then
610            _notrun "not suitable for image option: $bad_opt"
611        fi
612    done
613}
614
615# this test requires that a specified command (executable) exists
616#
617_require_command()
618{
619    if [ "$1" = "QEMU" ]; then
620        c=$QEMU_PROG
621    elif [ "$1" = "QEMU_IMG" ]; then
622        c=$QEMU_IMG_PROG
623    elif [ "$1" = "QEMU_IO" ]; then
624        c=$QEMU_IO_PROG
625    elif [ "$1" = "QEMU_NBD" ]; then
626        c=$QEMU_NBD_PROG
627    else
628        eval c=\$$1
629    fi
630    [ -x "$c" ] || _notrun "$1 utility required, skipped this test"
631}
632
633# Check that a set of drivers has been whitelisted in the QEMU binary
634#
635_require_drivers()
636{
637    available=$($QEMU -drive format=help | \
638                sed -e '/Supported formats:/!d' -e 's/Supported formats://')
639    for driver
640    do
641        if ! echo "$available" | grep -q " $driver\( \|$\)"; then
642            _notrun "$driver not available"
643        fi
644    done
645}
646
647# Check that we have a file system that allows huge (but very sparse) files
648#
649_require_large_file()
650{
651    if ! truncate --size="$1" "$TEST_IMG"; then
652        _notrun "file system on $TEST_DIR does not support large enough files"
653    fi
654    rm "$TEST_IMG"
655}
656
657# make sure this script returns success
658true
659